/* Copyright (c) 1997, MpegTV LLC */

#ifndef lint
static char rcsid[] = "$Header: /net/hopkins/var/home/tristan/mpeg/dec/RCS/ci_file.c,v 1.2 1997/08/21 11:51:26 tristan Exp $";
static char copyright[] = "Copyright (c) 1997, MpegTV LLC";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#include "misc.h"

#include "sii_api.h"


/*--------------------------------------------------------------------------+
| _init																		|
+--------------------------------------------------------------------------*/
int
_init()
{
	/*
	 * If the library exports a routine named  _init(),  then  that
     * code  is  executed  before  dlopen()  returns.
     */

	printf("_init(): loading custom stream interface\n");
		
	return 0;
}


/*--------------------------------------------------------------------------+
| _fini																		|
+--------------------------------------------------------------------------*/
int
_fini()
{
	/*
	 * If the dynamic library exports a routine named _fini(),
	 * then that routine is called just before the library is unloaded.
	 */

	printf("_fini(): unloading custom stream interface\n");
		
	return 0;
}

/*--------------------------------------------------------------------------+
| SII_open																	|
+--------------------------------------------------------------------------*/
int
SII_open(data, size)
	const void *data;	/* assumed to be a filename in this example */
	u_int		size;	/* ignored in this example */
{
	const char *filename = (const char *)data;
	
	printf("SII_open(\"%s\", %u)\n", filename, size);
	
	/* check that sii_feedback() works */
	sii_feedback(data, size);
		
	return open(filename, O_RDONLY);
}

/*--------------------------------------------------------------------------+
| SII_close																	|
+--------------------------------------------------------------------------*/
int
SII_close(fd)
	int		fd;
{
	printf("SII_close(%d)\n", fd);
	
	return close(fd);
}


/*--------------------------------------------------------------------------+
| SII_read																	|
+--------------------------------------------------------------------------*/
int
SII_read(fd, buf, count)
	int		fd;
	char *buf;
	size_t count;
{
	printf("SII_read(%d, buf, %d)\n", fd, count);
	
	return read(fd, buf, count);
}



/*--------------------------------------------------------------------------+
| SII_lseek																	|
+--------------------------------------------------------------------------*/
off_t
SII_lseek(fd, offset, whence)
	int		fd;
	off_t offset;
	int whence;
{
	printf("SII_lseek(%d, %ldL, %d)\n", fd, (long)offset, whence);
	
	return lseek(fd, offset, whence);
}


/*--------------------------------------------------------------------------+
| SII_cntl																	|
+--------------------------------------------------------------------------*/
int
SII_cntl(fd, data, size)
	int		fd;
	const void *data;
	u_int		size;
{
	printf("SII_cntl(%d, data, %u)\n", fd, size);
	
	return 0;
}


/* eof */
